SystemOrganization addCategory: #SqueakSVNPlugins!

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 04:13'!
answerSeventeen

	self export: true.
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: 16).! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rt 2/11/2008 13:38'!
convertOopToCString: anOop
	"This method converts an oop to a c sting.
	Free the result !!!!!!"

	| lengthOfOop tmpString resultString |
	self export: false.
	self returnTypeC: 'char*'.
	self var: #tmpString declareC: 'char* tmpString'.
	self var: #resultString declareC: 'char* resultString'.
		
	lengthOfOop := interpreterProxy slotSizeOf: anOop.
	tmpString := interpreterProxy firstIndexableField: anOop.
	self cCode: 'resultString = (char*) malloc(lengthOfOop + 1)'.

	"converting"
	0 to: lengthOfOop - 1 do: [:indexOfChar |
		resultString at: indexOfChar put: (tmpString at: indexOfChar)].
	self cCode: 'resultString[lengthOfOop] = ''\0'''.
	
	self cCode: 'return resultString'! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 04:15'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/11/2008 14:03'!
svnAdd: targetOop

	| target |
	self export: true.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAdd' parameters: #(Oop ).
	
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addTargetToWC (target)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rt 2/11/2008 13:50'!
svnCheckoutWorgingCopyFrom: aURLOop To: aPathOop

	| url path |
	self export: true.
	self var: 'url' declareC: 'char* url'.
	self var: 'path' declareC: 'char* path'.
	self primitive: 'svnCheckoutWorgingCopyFromTo' parameters: #(Oop Oop ).

	url := self convertOopToCString: aURLOop.
	path := self convertOopToCString: aPathOop.

	"Call SVNWrapper function"
	self cCode: 'checkoutWorkingCopyFormTo(url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/11/2008 14:09'!
svnCommit: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnCommit' parameters: #(Oop ).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'commit( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/11/2008 14:18'!
svnGetHeadRevision: targetOop

	| target revision |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #revision declareC: 'int revision'.
	self primitive: 'svnGetHeadRevision' parameters: #(Oop ).
	
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'getHeadRevisionOf(target, &revision)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	"interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: revision)."
	^interpreterProxy integerObjectOf: revision! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rkrk 2/6/2008 15:11'!
svnModifiedAdd

	| targetStringObj target targetLength tmpString value |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #value declareC: 'int value'.
	self var: #tmpString declareC: 'char* tmpString'.
	targetStringObj := interpreterProxy stackValue: 0. 
	targetLength := interpreterProxy slotSizeOf: targetStringObj.
	
	tmpString := interpreterProxy firstIndexableField: targetStringObj.
	self cCode: 'target = (char*) malloc(targetLength + 1)'.
	0 to: targetLength -1 do: [:stringIndex |
		target at: stringIndex put: (tmpString at: stringIndex)].
	self cCode: 'target[targetLength] = ''\0'''.
	
	"Call SVNWrapper function"
	self cCode: 'value = 0'.
	self cCode: 'callAddAndSetValueToOne(target, &value)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: value).! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 14:28'!
writeString

	| stringObj stringPtr |
	self export: true.
	self var: #stringObj declareC: 'int stringObj'. 
	self var: #stringPtr declareC: 'char *stringPtr'.
	stringObj := interpreterProxy stackValue: 0. 
	stringPtr := self 
		cCoerce: (interpreterProxy arrayValueOf: stringObj) 
		to: 'char *'.! !
